part of light_server;

final RegExp rint = new RegExp(r'^[0-9]+$');
final RegExp rdouble = new RegExp(r'^[0-9]+(\.[0-9]+)?$');

class ParamsChecker {
  static bool check(List<ParameterMirror> reference, List<Object> params){
    // Loop as long as it isn't named or that it is shorter than the number of arguments provided.
    for(int i = 1; i < Math.min(params.length, reference.length) && !reference[i].isNamed; i++) {
      if(reference[i].type.qualifiedName == #dart.core.int) {
        if(!rint.hasMatch(params[i]))
          return false;
        params[i] = int.parse(params[i]);
      }
      else if(reference[i].type.qualifiedName == #dart.core.double || reference[i].type.qualifiedName == #dart.core.num) {
        if(!rdouble.hasMatch(params[i]))
          return false;
        params[i] = double.parse(params[i]);
      }
    }
    return true;
  }
}

class NamedFiller {
  static Map<Symbol, dynamic> check(List<ParameterMirror> reference, Map<String, String> post){
    Map<Symbol, dynamic> toFill = new Map();
    reference.where((e)=>e.isNamed).forEach((e){
      Symbol name = e.simpleName;
      String p = post[MirrorSystem.getName(name)];
      if(p == null);
      else if(e.type.qualifiedName == #dart.core.String) {
        toFill[name] = p;
      }
      else if(e.type.qualifiedName == #dart.core.int) {
        if(rint.hasMatch(p))
          toFill[name] = int.parse(p);
      }
      else if(e.type.qualifiedName == #dart.core.double || e.type.qualifiedName == #dart.core.num) {
        if(rdouble.hasMatch(p))
          toFill[name] = double.parse(p);
      }
    });
    return toFill;
  }
}

class Route {
}